#pragma once
/*
PreHook
stmdb sp!, {r3}
; N lr si PostHook A PostHook DӦ^쨺
mov r3, pc
add r3, r3, #0x1C
str lr, [r3]
ldmia sp, {r3}
add sp, sp, #4
; call Hook procedure
mov lr, pc
ldr pc, [pc, #0x8]
; ^
ldr lr, [pc, #0]
mov pc, lr
*/

extern "C"
{
	DWORD SetKMode(DWORD);
	DWORD SetProcPermissions(DWORD);
}

namespace stools { namespace hook {

	struct HookSturct
	{
		// PreHook
		int		codePrehook[10];
		int		addrRet;
		int		addrHookProc;
		// Original API
		int		codeBegin[4];
		int		codeNop;
		int		addrBackAPI;
	};

	void* HookFunction(void* funcOriginal, void* funcHook)
	{
		int codePreHook[10] = {
			0xe92d0008, 0xe1a0300f, 0xe283301c, 0xe583e000, 0xe89d0008, 
			0xe28dd004, 0xe1a0e00f, 0xe59ff008, 0xe59fe000, 0xe1a0f00e
		};

		int codeHook[3] = {0xe59ff000, 0xe1a08008, 0};

		HookSturct* hookObj = new HookSturct;
		CopyMemory(hookObj, codePreHook, 10 * sizeof(int));

		hookObj->addrHookProc = (int) funcHook;
		hookObj->addrBackAPI = (int) ((int*)funcOriginal + 3);
		hookObj->codeBegin[0] = *(int*)funcOriginal;
		hookObj->codeBegin[1] = *((int*)funcOriginal + 1);
		hookObj->codeBegin[2] = *((int*)funcOriginal + 2);
		hookObj->codeBegin[3] = 0xe59ff000;
		hookObj->codeNop = 0xe1a08008;

		codeHook[2] = (int) hookObj;

		SetKMode(TRUE);
		if (!SetKMode(TRUE))
			OutputDebugString(L"Failed\n");

		MEMORY_BASIC_INFORMATION mbi = {0};
		VirtualQuery(funcOriginal, &mbi, sizeof(mbi));

		DWORD nProtect = 0;
		VirtualProtect(mbi.BaseAddress, mbi.RegionSize, PAGE_EXECUTE_READWRITE, &nProtect);

		((int*)funcOriginal)[0] = codeHook[0];
		((int*)funcOriginal)[1] = codeHook[1];
		((int*)funcOriginal)[2] = codeHook[2];

		VirtualProtect(mbi.BaseAddress, mbi.RegionSize, nProtect, &nProtect);

		SetKMode(FALSE);

		return (void*)((int*)hookObj + 12);
	}

	void UnhookFunction(void* funcHandler)
	{
		HookSturct* hookObj = (HookSturct*)((int*)funcHandler - 12);
		int* pFunctionBegin = (int*) (hookObj->addrBackAPI - 12);

		MEMORY_BASIC_INFORMATION mbi = {0};
		VirtualQuery(pFunctionBegin, &mbi, sizeof(mbi));

		DWORD nProtect = 0;
		VirtualProtect(mbi.BaseAddress, mbi.RegionSize, PAGE_EXECUTE_READWRITE, &nProtect);

		pFunctionBegin[0] = hookObj->codeBegin[0];
		pFunctionBegin[1] = hookObj->codeBegin[1];
		pFunctionBegin[2] = hookObj->codeBegin[2];

		VirtualProtect(mbi.BaseAddress, mbi.RegionSize, nProtect, &nProtect);

		delete hookObj;
	}
} }